diff --git a/docs/api/IoT.js-API-PWM.md b/docs/api/IoT.js-API-PWM.md
index 78af9da85..c5cd09c4f 100644
--- a/docs/api/IoT.js-API-PWM.md
+++ b/docs/api/IoT.js-API-PWM.md
@@ -5,6 +5,7 @@ The following shows PWM module APIs available for each platform.
 |  | Linux<br/>(Ubuntu) | Raspbian<br/>(Raspberry Pi) | NuttX<br/>(STM32F4-Discovery) | TizenRT<br/>(Artik053) |
 | :---: | :---: | :---: | :---: | :---: |
 | pwm.open | O | O | O | O |
+| pwm.openSync | O | O | O | O |
 | pwmpin.setPeriod | O | O | O | O |
 | pwmpin.setPeriodSync | O | O | O | O |
 | pwmpin.setFrequency | O | O | O | O |
@@ -47,8 +48,7 @@ To correctly open a PWM pin one must know the correct pin number:
 
 **Example**
 ```js
-var Pwm = require('pwm');
-var pwm = new Pwm();
+var pwm = require('pwm');
 var config = {
   pin: 0,
   period: 0.1,
@@ -61,6 +61,34 @@ var pwm0 = pwm.open(config, function(err) {
 });
 ```
 
+### pwm.openSync(configuration)
+* `configuration` {Object} Configuration object which can have the following properties.
+  * `pin` {number} The pin number to use with this PWM object (mandatory configuration).
+  * `chip` {number} The PWM chip number (only on Linux). **Default:** `0`.
+  * `period` {number} The period of the PWM signal, in seconds (positive number).
+  * `frequency` {integer} In Hz (positive integer).
+  * `dutyCycle` {number} The active time of the PWM signal, must be within the `0.0` and `1.0` range.
+* Returns: `<PWMPin>`
+
+Opens PWM pin with the specified configuration.
+
+To correctly open a PWM pin one must know the correct pin number:
+* On Linux, `pin` is a number which is `0` or `1`.
+* On NuttX, you have to know pin name. The pin name is defined in target board module. For more module information, please see below list.
+  * [STM32F4-discovery](../targets/nuttx/stm32f4dis/IoT.js-API-Stm32f4dis.md#pwm-pin)
+
+
+**Example**
+```js
+var pwm = require('pwm');
+var config = {
+  pin: 0,
+  period: 0.1,
+  dutyCycle: 0.5
+}
+var pwm0 = pwm.openSync(config);
+```
+
 
 ## Class: PWMPin
 
diff --git a/samples/fur-elise/play.js b/samples/fur-elise/play.js
index 755f292c3..1cb8f7e9e 100644
--- a/samples/fur-elise/play.js
+++ b/samples/fur-elise/play.js
@@ -27,8 +27,7 @@
  *
  */
 
-var PWM = require('pwm'),
-  pwm = new PWM(),
+var pwm = require('pwm'),
   // note indexes definition
   // please remember that D# is same as Bb here
   notes = {
diff --git a/samples/light-fade/light-fade.js b/samples/light-fade/light-fade.js
index 387ef8b23..72afcbcf8 100644
--- a/samples/light-fade/light-fade.js
+++ b/samples/light-fade/light-fade.js
@@ -30,8 +30,7 @@
  *
  */
 
-var PWM = require('pwm'),
-  pwm = new PWM(),
+var pwm = require('pwm'),
   GPIO = require('gpio'),
   gpio = new GPIO(),
   LOW = 0,
diff --git a/src/iotjs_magic_strings.h b/src/iotjs_magic_strings.h
index 18f60c1e6..e83a689d0 100644
--- a/src/iotjs_magic_strings.h
+++ b/src/iotjs_magic_strings.h
@@ -250,7 +250,11 @@
 #endif
 #if ENABLE_MODULE_PWM
 #define IOTJS_MAGIC_STRING_SETDUTYCYCLE "setDutyCycle"
+#define IOTJS_MAGIC_STRING_SETDUTYCYCLESYNC "setDutyCycleSync"
 #define IOTJS_MAGIC_STRING_SETENABLE "setEnable"
+#define IOTJS_MAGIC_STRING_SETENABLESYNC "setEnableSync"
+#define IOTJS_MAGIC_STRING_SETFREQUENCY "setFrequency"
+#define IOTJS_MAGIC_STRING_SETFREQUENCYSYNC "setFrequencySync"
 #endif
 #if ENABLE_MODULE_BLE
 #define IOTJS_MAGIC_STRING_SETFILTER "setFilter"
@@ -262,6 +266,7 @@
 #endif
 #if ENABLE_MODULE_PWM
 #define IOTJS_MAGIC_STRING_SETPERIOD "setPeriod"
+#define IOTJS_MAGIC_STRING_SETPERIODSYNC "setPeriodSync"
 #endif
 #define IOTJS_MAGIC_STRING_SETTIMEOUT "setTimeout"
 #if ENABLE_MODULE_DGRAM
diff --git a/src/js/pwm.js b/src/js/pwm.js
index 15b115cb4..0fb2fcbd4 100644
--- a/src/js/pwm.js
+++ b/src/js/pwm.js
@@ -13,228 +13,16 @@
  * limitations under the License.
  */
 
-var util = require('util');
-
-
-function Pwm() {
-  if (!(this instanceof Pwm)) {
-    return new Pwm();
-  }
-}
-
-Pwm.prototype.open = function(configuration, callback) {
-  return pwmPinOpen(configuration, callback);
-};
-
-
-function pwmPinOpen(configuration, callback) {
-  var _binding = null;
-
-  function PwmPin(configuration, callback) {
-    var self = this;
-    self._configuration = {};
-
-    if (util.isObject(configuration)) {
-      if (process.platform === 'linux') {
-        if (util.isNumber(configuration.chip)) {
-          self._configuration.chip = configuration.chip;
-        } else {
-          self._configuration.chip = 0;
-        }
-      }
-
-      if (!util.isNumber(configuration.pin)) {
-        throw new TypeError(
-          'Bad configuration - pin is mandatory and should be Number');
-      } else {
-        self._configuration.pin = configuration.pin;
-      }
-    } else {
-      throw new TypeError('Bad arguments - configuration should be Object');
-    }
-
-    // validate configuration
-    var dutyCycle = configuration.dutyCycle;
-    var period = configuration.period;
-    if (!util.isNumber(period) && util.isNumber(configuration.frequency)) {
-      period = 1.0 / configuration.frequency;
-    }
-
-    if (util.isNumber(dutyCycle) && dutyCycle >= 0.0 && dutyCycle <= 1.0 &&
-      util.isNumber(period) && util.isFinite(period) && period > 0) {
-      self._configuration.dutyCycle = dutyCycle;
-      self._configuration.period = period;
-    }
-
-    _binding = new native(self._configuration, function(err) {
-      util.isFunction(callback) && callback.call(self, err);
+var pwm = {
+  open: function(config, callback) {
+    var pwmPin = new native(config, function(err) {
+      callback(err, pwmPin);
     });
-
-    process.on('exit', (function(self) {
-      return function() {
-        if (_binding !== null) {
-          self.closeSync();
-        }
-      };
-    })(this));
+    return pwmPin;
+  },
+  openSync: function(config) {
+    return new native(config);
   }
+};
 
-  PwmPin.prototype._validatePeriod = function(period) {
-    if (!util.isNumber(period)) {
-      throw new TypeError('Period is not a number(' + typeof(period) + ')');
-    } else if (period < 0) {
-      throw new RangeError('Period(' + period + ') is negative');
-    }
-    return true;
-  };
-
-  PwmPin.prototype._validateFrequency = function(frequency) {
-    if (!util.isNumber(frequency)) {
-      throw new TypeError('Frequency is not a number(' +
-        typeof(frequency) + ')');
-    } else if (frequency <= 0) {
-      throw RangeError('Nonpositivie frequency of ' + frequency);
-    }
-    return true;
-  };
-
-  PwmPin.prototype._validateDutyCycle = function(dutyCycle) {
-    if (!util.isNumber(dutyCycle)) {
-      throw TypeError('DutyCycle is not a number(' + typeof(dutyCycle) + ')');
-    } else if (dutyCycle < 0.0 || dutyCycle > 1.0) {
-      throw RangeError('DutyCycle of ' + dutyCycle + ' out of bounds [0..1]');
-    }
-    return true;
-  };
-
-  PwmPin.prototype.setPeriod = function(period, callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    if (this._validatePeriod(period)) {
-      _binding.setPeriod(period, function(err) {
-        util.isFunction(callback) && callback.call(self, err);
-      });
-    }
-  };
-
-  PwmPin.prototype.setPeriodSync = function(period) {
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    if (this._validatePeriod(period)) {
-      _binding.setPeriod(period);
-    }
-  };
-
-  PwmPin.prototype.setFrequency = function(frequency, callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    if (this._validateFrequency(frequency)) {
-      _binding.setPeriod(1.0 / frequency, function(err) {
-        util.isFunction(callback) && callback.call(self, err);
-      });
-    }
-  };
-
-  PwmPin.prototype.setFrequencySync = function(frequency) {
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    if (this._validateFrequency(frequency)) {
-      _binding.setPeriod(1.0 / frequency);
-    }
-  };
-
-  PwmPin.prototype.setDutyCycle = function(dutyCycle, callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    // Check arguments.
-    if (this._validateDutyCycle(dutyCycle)) {
-      _binding.setDutyCycle(dutyCycle, function(err) {
-        util.isFunction(callback) && callback.call(self, err);
-      });
-    }
-  };
-
-  PwmPin.prototype.setDutyCycleSync = function(dutyCycle) {
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    // Check arguments.
-    if (this._validateDutyCycle(dutyCycle)) {
-      _binding.setDutyCycle(dutyCycle);
-    }
-  };
-
-  PwmPin.prototype.setEnable = function(enable, callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    // Check arguments.
-    if (!util.isNumber(enable) && !util.isBoolean(enable)) {
-      throw new TypeError('enable is of type ' + typeof(enable));
-    }
-
-    _binding.setEnable(!!enable, function(err) {
-      util.isFunction(callback) && callback.call(self, err);
-    });
-  };
-
-  PwmPin.prototype.setEnableSync = function(enable) {
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    // Check arguments.
-    if (!util.isNumber(enable) && !util.isBoolean(enable)) {
-      throw new TypeError('enable is of type ' + typeof(enable));
-    }
-
-    _binding.setEnable(!!enable);
-  };
-
-  PwmPin.prototype.close = function(callback) {
-    var self = this;
-
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    _binding.close(function(err) {
-      util.isFunction(callback) && callback.call(self, err);
-      _binding = null;
-    });
-  };
-
-  PwmPin.prototype.closeSync = function() {
-    if (_binding === null) {
-      throw new Error('Pwm pin is not opened');
-    }
-
-    _binding.close();
-    _binding = null;
-  };
-
-  return new PwmPin(configuration, callback);
-}
-
-
-module.exports = Pwm;
+module.exports = pwm;
diff --git a/src/modules.json b/src/modules.json
index ad5252e06..efddef064 100644
--- a/src/modules.json
+++ b/src/modules.json
@@ -254,8 +254,7 @@
       },
       "native_files": ["modules/iotjs_module_pwm.c"],
       "init": "InitPwm",
-      "js_file": "js/pwm.js",
-      "require": ["util"]
+      "js_file": "js/pwm.js"
     },
     "spi": {
       "platforms": {
diff --git a/src/modules/iotjs_module_pwm.c b/src/modules/iotjs_module_pwm.c
index 2a47dcf4c..bf7414666 100644
--- a/src/modules/iotjs_module_pwm.c
+++ b/src/modules/iotjs_module_pwm.c
@@ -13,42 +13,25 @@
  * limitations under the License.
  */
 
+
 #include "iotjs_def.h"
 #include "iotjs_module_pwm.h"
 
 
-static iotjs_pwm_t* iotjs_pwm_instance_from_jval(jerry_value_t jpwm);
-
 IOTJS_DEFINE_NATIVE_HANDLE_INFO_THIS_MODULE(pwm);
 
-
-static iotjs_pwm_t* iotjs_pwm_create(jerry_value_t jpwm) {
+static iotjs_pwm_t* pwm_create(jerry_value_t jpwm) {
   iotjs_pwm_t* pwm = IOTJS_ALLOC(iotjs_pwm_t);
   IOTJS_VALIDATED_STRUCT_CONSTRUCTOR(iotjs_pwm_t, pwm);
+  iotjs_pwm_create_platform_data(pwm);
   _this->jobject = jpwm;
-  jerry_set_object_native_pointer(jpwm, pwm, &this_module_native_info);
-
   _this->period = -1;
   _this->duty_cycle = 0;
-#if defined(__NUTTX__)
-  _this->device_fd = -1;
-#endif
-  return pwm;
-}
-
+  jerry_set_object_native_pointer(jpwm, pwm, &this_module_native_info);
 
-static void iotjs_pwm_destroy(iotjs_pwm_t* pwm) {
-#if defined(__linux__)
-  IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_pwm_t, pwm);
-  iotjs_string_destroy(&_this->device);
-#endif
-  IOTJS_RELEASE(pwm);
+  return pwm;
 }
 
-
-#define THIS iotjs_pwm_reqwrap_t* pwm_reqwrap
-
-
 static iotjs_pwm_reqwrap_t* iotjs_pwm_reqwrap_create(jerry_value_t jcallback,
                                                      iotjs_pwm_t* pwm,
                                                      PwmOp op) {
@@ -58,153 +41,121 @@ static iotjs_pwm_reqwrap_t* iotjs_pwm_reqwrap_create(jerry_value_t jcallback,
   iotjs_reqwrap_initialize(&_this->reqwrap, jcallback, (uv_req_t*)&_this->req);
 
   _this->req_data.op = op;
-  _this->pwm_instance = pwm;
-  _this->req_data.caller = NULL;
+  _this->pwm_data = pwm;
 
   return pwm_reqwrap;
 }
 
-
-static void iotjs_pwm_reqwrap_destroy(THIS) {
+static void pwm_reqwrap_destroy(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_pwm_reqwrap_t, pwm_reqwrap);
   iotjs_reqwrap_destroy(&_this->reqwrap);
   IOTJS_RELEASE(pwm_reqwrap);
 }
 
-
-static void iotjs_pwm_reqwrap_dispatched(THIS) {
+static void pwm_reqwrap_dispatched(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATABLE_STRUCT_METHOD_VALIDATE(iotjs_pwm_reqwrap_t, pwm_reqwrap);
-  iotjs_pwm_reqwrap_destroy(pwm_reqwrap);
+  pwm_reqwrap_destroy(pwm_reqwrap);
 }
 
-
-static uv_work_t* iotjs_pwm_reqwrap_req(THIS) {
+static uv_work_t* pwm_reqwrap_req(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_reqwrap_t, pwm_reqwrap);
   return &_this->req;
 }
 
-
-static jerry_value_t iotjs_pwm_reqwrap_jcallback(THIS) {
+static jerry_value_t pwm_reqwrap_jcallback(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_reqwrap_t, pwm_reqwrap);
   return iotjs_reqwrap_jcallback(&_this->reqwrap);
 }
 
-
-static iotjs_pwm_t* iotjs_pwm_instance_from_jval(jerry_value_t jpwm) {
-  uintptr_t handle = iotjs_jval_get_object_native_handle(jpwm);
-  return (iotjs_pwm_t*)handle;
-}
-
-
 iotjs_pwm_reqwrap_t* iotjs_pwm_reqwrap_from_request(uv_work_t* req) {
   return (iotjs_pwm_reqwrap_t*)(iotjs_reqwrap_from_request((uv_req_t*)req));
 }
 
-
-iotjs_pwm_reqdata_t* iotjs_pwm_reqwrap_data(THIS) {
+iotjs_pwm_reqdata_t* iotjs_pwm_reqwrap_data(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_reqwrap_t, pwm_reqwrap);
   return &_this->req_data;
 }
 
-
-iotjs_pwm_t* iotjs_pwm_instance_from_reqwrap(THIS) {
+iotjs_pwm_t* iotjs_pwm_instance_from_reqwrap(iotjs_pwm_reqwrap_t* pwm_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_reqwrap_t, pwm_reqwrap);
-  return _this->pwm_instance;
+  return _this->pwm_data;
 }
 
-
-static void iotjs_pwm_set_configuration(jerry_value_t jconfiguration,
-                                        iotjs_pwm_t* pwm) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
-
-  jerry_value_t jpin =
-      iotjs_jval_get_property(jconfiguration, IOTJS_MAGIC_STRING_PIN);
-  _this->pin = iotjs_jval_as_number(jpin);
-
-#if defined(__linux__)
-  jerry_value_t jchip =
-      iotjs_jval_get_property(jconfiguration, IOTJS_MAGIC_STRING_CHIP);
-  _this->chip = iotjs_jval_as_number(jchip);
-  jerry_release_value(jchip);
-#endif
-
-  jerry_value_t jperiod =
-      iotjs_jval_get_property(jconfiguration, IOTJS_MAGIC_STRING_PERIOD);
-  if (jerry_value_is_number(jperiod))
-    _this->period = iotjs_jval_as_number(jperiod);
-
-  jerry_value_t jduty_cycle =
-      iotjs_jval_get_property(jconfiguration, IOTJS_MAGIC_STRING_DUTYCYCLE);
-  if (jerry_value_is_number(jduty_cycle))
-    _this->duty_cycle = iotjs_jval_as_number(jduty_cycle);
-
-  jerry_release_value(jpin);
-  jerry_release_value(jperiod);
-  jerry_release_value(jduty_cycle);
+static void iotjs_pwm_destroy(iotjs_pwm_t* pwm) {
+  IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_pwm_t, pwm);
+  iotjs_pwm_destroy_platform_data(_this->platform_data);
+  IOTJS_RELEASE(pwm);
 }
 
-#undef THIS
-
-
-static void iotjs_pwm_common_worker(uv_work_t* work_req) {
-  PWM_WORKER_INIT;
-
-  IOTJS_ASSERT(req_data->caller != NULL);
-
-  if (!req_data->caller(pwm)) {
-    req_data->result = false;
-    return;
+static void pwm_worker(uv_work_t* work_req) {
+  iotjs_pwm_reqwrap_t* req_wrap = iotjs_pwm_reqwrap_from_request(work_req);
+  iotjs_pwm_reqdata_t* req_data = iotjs_pwm_reqwrap_data(req_wrap);
+  iotjs_pwm_t* pwm = iotjs_pwm_instance_from_reqwrap(req_wrap);
+
+  switch (req_data->op) {
+    case kPwmOpClose:
+      req_data->result = iotjs_pwm_close(pwm);
+      break;
+    case kPwmOpOpen:
+      req_data->result = iotjs_pwm_open(pwm);
+      break;
+    case kPwmOpSetDutyCycle:
+      req_data->result = iotjs_pwm_set_dutycycle(pwm);
+      break;
+    case kPwmOpSetEnable:
+      req_data->result = iotjs_pwm_set_enable(pwm);
+      break;
+    case kPwmOpSetFrequency: /* update the period */
+    case kPwmOpSetPeriod:
+      req_data->result = iotjs_pwm_set_period(pwm);
+      break;
+    default:
+      IOTJS_ASSERT(!"Invalid Operation");
   }
-
-  req_data->result = true;
 }
 
+static const char* pwm_error_str(int op) {
+  switch (op) {
+    case kPwmOpClose:
+      return "Cannot close PWM device";
+    case kPwmOpOpen:
+      return "Failed to open PWM device";
+    case kPwmOpSetDutyCycle:
+      return "Failed to set duty-cycle";
+    case kPwmOpSetEnable:
+      return "Failed to set enable";
+    case kPwmOpSetFrequency:
+      return "Failed to set frequency";
+    case kPwmOpSetPeriod:
+      return "Failed to set period";
+    default:
+      return "Unknown error";
+  }
+}
 
-static void iotjs_pwm_after_worker(uv_work_t* work_req, int status) {
+static void pwm_after_worker(uv_work_t* work_req, int status) {
   iotjs_pwm_reqwrap_t* req_wrap = iotjs_pwm_reqwrap_from_request(work_req);
   iotjs_pwm_reqdata_t* req_data = iotjs_pwm_reqwrap_data(req_wrap);
+
   iotjs_jargs_t jargs = iotjs_jargs_create(1);
-  bool result = req_data->result;
 
   if (status) {
     iotjs_jargs_append_error(&jargs, "System error");
   } else {
     switch (req_data->op) {
+      case kPwmOpClose:
       case kPwmOpOpen:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to open PWM device");
-        } else {
-          iotjs_jargs_append_null(&jargs);
-        }
-        break;
       case kPwmOpSetDutyCycle:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to set duty-cycle");
-        } else {
-          iotjs_jargs_append_null(&jargs);
-        }
-        break;
-      case kPwmOpSetPeriod:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to set period");
-        } else {
-          iotjs_jargs_append_null(&jargs);
-        }
-        break;
       case kPwmOpSetEnable:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Failed to set enable");
-        } else {
-          iotjs_jargs_append_null(&jargs);
-        }
-        break;
-      case kPwmOpClose:
-        if (!result) {
-          iotjs_jargs_append_error(&jargs, "Cannot close PWM device");
+      case kPwmOpSetFrequency:
+      case kPwmOpSetPeriod: {
+        if (!req_data->result) {
+          iotjs_jargs_append_error(&jargs, pwm_error_str(req_data->op));
         } else {
           iotjs_jargs_append_null(&jargs);
         }
         break;
+      }
       default: {
         IOTJS_ASSERT(!"Unreachable");
         break;
@@ -212,86 +163,83 @@ static void iotjs_pwm_after_worker(uv_work_t* work_req, int status) {
     }
   }
 
-  jerry_value_t jcallback = iotjs_pwm_reqwrap_jcallback(req_wrap);
-  iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  jerry_value_t jcallback = pwm_reqwrap_jcallback(req_wrap);
+  if (jerry_value_is_function(jcallback)) {
+    iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  }
 
   iotjs_jargs_destroy(&jargs);
-
-  iotjs_pwm_reqwrap_dispatched(req_wrap);
+  pwm_reqwrap_dispatched(req_wrap);
 }
 
-
-#define PWM_ASYNC(call, this, jcallback, op)                           \
+#define PWM_CALL_ASYNC(op, jcallback)                                  \
   do {                                                                 \
     uv_loop_t* loop = iotjs_environment_loop(iotjs_environment_get()); \
     iotjs_pwm_reqwrap_t* req_wrap =                                    \
-        iotjs_pwm_reqwrap_create(jcallback, this, op);                 \
-    uv_work_t* req = iotjs_pwm_reqwrap_req(req_wrap);                  \
-    uv_queue_work(loop, req, iotjs_pwm_##call##_worker,                \
-                  iotjs_pwm_after_worker);                             \
-  } while (0)
-
-
-#define PWM_ASYNC_COMMON_WORKER(call, this, jcallback, op)                     \
-  do {                                                                         \
-    uv_loop_t* loop = iotjs_environment_loop(iotjs_environment_get());         \
-    iotjs_pwm_reqwrap_t* req_wrap =                                            \
-        iotjs_pwm_reqwrap_create(jcallback, this, op);                         \
-    uv_work_t* req = iotjs_pwm_reqwrap_req(req_wrap);                          \
-    iotjs_pwm_reqdata_t* req_data = iotjs_pwm_reqwrap_data(req_wrap);          \
-    req_data->caller = call;                                                   \
-    uv_queue_work(loop, req, iotjs_pwm_common_worker, iotjs_pwm_after_worker); \
+        iotjs_pwm_reqwrap_create(jcallback, pwm, op);                  \
+    uv_work_t* req = pwm_reqwrap_req(req_wrap);                        \
+    uv_queue_work(loop, req, pwm_worker, pwm_after_worker);            \
   } while (0)
 
-
-JS_FUNCTION(PWMConstructor) {
+JS_FUNCTION(PwmCons) {
   DJS_CHECK_THIS();
-  DJS_CHECK_ARGS(2, object, function);
+  DJS_CHECK_ARGS(1, object);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
   // Create PWM object
   jerry_value_t jpwm = JS_GET_THIS();
-  iotjs_pwm_t* pwm = iotjs_pwm_create(jpwm);
-  IOTJS_ASSERT(pwm == iotjs_pwm_instance_from_jval(jpwm));
+  iotjs_pwm_t* pwm = pwm_create(jpwm);
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
 
-  jerry_value_t jconfiguration = JS_GET_ARG(0, object);
-  jerry_value_t jcallback = JS_GET_ARG(1, function);
+  jerry_value_t jconfig;
+  JS_GET_REQUIRED_ARG_VALUE(0, jconfig, IOTJS_MAGIC_STRING_CONFIG, object);
 
-  // Set configuration
-  iotjs_pwm_set_configuration(jconfiguration, pwm);
+  jerry_value_t res = iotjs_pwm_set_platform_config(pwm, jconfig);
+  if (jerry_value_has_error_flag(res)) {
+    return res;
+  }
+
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, _this->duty_cycle,
+                              IOTJS_MAGIC_STRING_DUTYCYCLE, number);
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, _this->period, IOTJS_MAGIC_STRING_PERIOD,
+                              number);
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, _this->pin, IOTJS_MAGIC_STRING_PIN,
+                              number);
 
-  PWM_ASYNC(open, pwm, jcallback, kPwmOpOpen);
+  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(1, function);
+
+  // If the callback doesn't exist, it is completed synchronously.
+  // Otherwise, it will be executed asynchronously.
+  if (!jerry_value_is_null(jcallback)) {
+    PWM_CALL_ASYNC(kPwmOpOpen, jcallback);
+  } else if (!iotjs_pwm_open(pwm)) {
+    return JS_CREATE_ERROR(COMMON, pwm_error_str(kPwmOpOpen));
+  }
 
   return jerry_create_undefined();
 }
 
-
-JS_FUNCTION(SetPeriod) {
+JS_FUNCTION(Close) {
   JS_DECLARE_THIS_PTR(pwm, pwm);
-
-  DJS_CHECK_ARGS(1, number);
   DJS_CHECK_ARG_IF_EXIST(1, function);
 
-  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(1, function);
+  PWM_CALL_ASYNC(kPwmOpClose, JS_GET_ARG_IF_EXIST(0, function));
 
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
-  _this->period = JS_GET_ARG(0, number);
+  return jerry_create_undefined();
+}
 
-  if (!jerry_value_is_null(jcallback)) {
-    PWM_ASYNC_COMMON_WORKER(iotjs_pwm_set_period, pwm, jcallback,
-                            kPwmOpSetPeriod);
-  } else {
-    if (!iotjs_pwm_set_period(pwm)) {
-      return JS_CREATE_ERROR(COMMON, "PWM SetPeriod Error");
-    }
+JS_FUNCTION(CloseSync) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+
+  if (!iotjs_pwm_close(pwm)) {
+    return JS_CREATE_ERROR(COMMON, pwm_error_str(kPwmOpClose));
   }
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
-
 JS_FUNCTION(SetDutyCycle) {
   JS_DECLARE_THIS_PTR(pwm, pwm);
-
   DJS_CHECK_ARGS(1, number);
   DJS_CHECK_ARG_IF_EXIST(1, function);
 
@@ -300,22 +248,27 @@ JS_FUNCTION(SetDutyCycle) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
   _this->duty_cycle = JS_GET_ARG(0, number);
 
-  if (!jerry_value_is_null(jcallback)) {
-    PWM_ASYNC_COMMON_WORKER(iotjs_pwm_set_dutycycle, pwm, jcallback,
-                            kPwmOpSetDutyCycle);
-  } else {
-    if (!iotjs_pwm_set_dutycycle(pwm)) {
-      return JS_CREATE_ERROR(COMMON, "PWM SetDutyCycle Error");
-    }
-  }
+  PWM_CALL_ASYNC(kPwmOpSetDutyCycle, jcallback);
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
+JS_FUNCTION(SetDutyCycleSync) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+  DJS_CHECK_ARGS(1, number);
+
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  _this->duty_cycle = JS_GET_ARG(0, number);
+
+  if (!iotjs_pwm_set_dutycycle(pwm)) {
+    return JS_CREATE_ERROR(COMMON, pwm_error_str(kPwmOpSetDutyCycle));
+  }
+
+  return jerry_create_undefined();
+}
 
 JS_FUNCTION(SetEnable) {
   JS_DECLARE_THIS_PTR(pwm, pwm);
-
   DJS_CHECK_ARGS(1, boolean);
   DJS_CHECK_ARG_IF_EXIST(1, function);
 
@@ -324,53 +277,106 @@ JS_FUNCTION(SetEnable) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
   _this->enable = JS_GET_ARG(0, boolean);
 
-  if (!jerry_value_is_null(jcallback)) {
-    PWM_ASYNC_COMMON_WORKER(iotjs_pwm_set_enable, pwm, jcallback,
-                            kPwmOpSetEnable);
+  PWM_CALL_ASYNC(kPwmOpSetEnable, jcallback);
+
+  return jerry_create_undefined();
+}
+
+JS_FUNCTION(SetEnableSync) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+  DJS_CHECK_ARGS(1, boolean);
+
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  _this->enable = JS_GET_ARG(0, boolean);
+
+  if (!iotjs_pwm_set_enable(pwm)) {
+    return JS_CREATE_ERROR(COMMON, pwm_error_str(kPwmOpSetEnable));
+  }
+
+  return jerry_create_undefined();
+}
+
+static jerry_value_t pwm_set_period_or_frequency(iotjs_pwm_t* pwm,
+                                                 const jerry_value_t jargv[],
+                                                 const jerry_length_t jargc,
+                                                 uint8_t op, bool async) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+
+  if (op == kPwmOpSetFrequency) {
+    _this->period = 1.0 / JS_GET_ARG(0, number);
   } else {
-    if (!iotjs_pwm_set_enable(pwm)) {
-      return JS_CREATE_ERROR(COMMON, "PWM SetEnabe Error");
+    _this->period = JS_GET_ARG(0, number);
+  }
+
+  if (async) {
+    PWM_CALL_ASYNC(op, JS_GET_ARG_IF_EXIST(1, function));
+  } else {
+    if (!iotjs_pwm_set_period(pwm)) {
+      return JS_CREATE_ERROR(COMMON, pwm_error_str(op));
     }
   }
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
+JS_FUNCTION(SetFrequency) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+  DJS_CHECK_ARGS(1, number);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
-JS_FUNCTION(Close) {
+  return pwm_set_period_or_frequency(pwm, jargv, jargc, kPwmOpSetFrequency,
+                                     true);
+}
+
+JS_FUNCTION(SetFrequencySync) {
   JS_DECLARE_THIS_PTR(pwm, pwm);
-  DJS_CHECK_ARG_IF_EXIST(0, function);
+  DJS_CHECK_ARGS(1, number);
 
-  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(0, function);
+  return pwm_set_period_or_frequency(pwm, jargv, jargc, kPwmOpSetFrequency,
+                                     false);
+}
 
-  if (!jerry_value_is_null(jcallback)) {
-    PWM_ASYNC_COMMON_WORKER(iotjs_pwm_close, pwm, jcallback, kPwmOpClose);
-  } else {
-    if (!iotjs_pwm_close(pwm)) {
-      return JS_CREATE_ERROR(COMMON, "PWM Close Error");
-    }
-  }
+JS_FUNCTION(SetPeriod) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+  DJS_CHECK_ARGS(1, number);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
-  return jerry_create_null();
+  return pwm_set_period_or_frequency(pwm, jargv, jargc, kPwmOpSetPeriod, true);
 }
 
+JS_FUNCTION(SetPeriodSync) {
+  JS_DECLARE_THIS_PTR(pwm, pwm);
+  DJS_CHECK_ARGS(1, number);
+
+  return pwm_set_period_or_frequency(pwm, jargv, jargc, kPwmOpSetPeriod, false);
+}
 
 jerry_value_t InitPwm() {
-  jerry_value_t jpwm_constructor =
-      jerry_create_external_function(PWMConstructor);
+  jerry_value_t jpwm_cons = jerry_create_external_function(PwmCons);
 
   jerry_value_t jprototype = jerry_create_object();
 
-  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETPERIOD, SetPeriod);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_CLOSE, Close);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_CLOSESYNC, CloseSync);
   iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETDUTYCYCLE,
                         SetDutyCycle);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETDUTYCYCLESYNC,
+                        SetDutyCycleSync);
   iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETENABLE, SetEnable);
-  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_CLOSE, Close);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETENABLESYNC,
+                        SetEnableSync);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETFREQUENCY,
+                        SetFrequency);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETFREQUENCYSYNC,
+                        SetFrequencySync);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETPERIOD, SetPeriod);
+  iotjs_jval_set_method(jprototype, IOTJS_MAGIC_STRING_SETPERIODSYNC,
+                        SetPeriodSync);
 
-  iotjs_jval_set_property_jval(jpwm_constructor, IOTJS_MAGIC_STRING_PROTOTYPE,
+  iotjs_jval_set_property_jval(jpwm_cons, IOTJS_MAGIC_STRING_PROTOTYPE,
                                jprototype);
 
   jerry_release_value(jprototype);
 
-  return jpwm_constructor;
+  return jpwm_cons;
 }
diff --git a/src/modules/iotjs_module_pwm.h b/src/modules/iotjs_module_pwm.h
index cbb4e7949..2920411cc 100644
--- a/src/modules/iotjs_module_pwm.h
+++ b/src/modules/iotjs_module_pwm.h
@@ -27,26 +27,28 @@
 
 
 typedef enum {
+  kPwmOpClose,
   kPwmOpOpen,
   kPwmOpSetDutyCycle,
-  kPwmOpSetPeriod,
-  kPwmOpSetFrequency,
   kPwmOpSetEnable,
-  kPwmOpClose,
+  kPwmOpSetFrequency,
+  kPwmOpSetPeriod
 } PwmOp;
 
 
+typedef struct {
+  bool result;
+  PwmOp op;
+} iotjs_pwm_reqdata_t;
+
+// Forward declaration of platform data. These are only used by platform code.
+// Generic PWM module never dereferences platform data pointer.
+typedef struct iotjs_pwm_platform_data_s iotjs_pwm_platform_data_t;
+
 typedef struct {
   jerry_value_t jobject;
+  iotjs_pwm_platform_data_t* platform_data;
 
-#if defined(__linux__)
-  int chip;
-  iotjs_string_t device;
-#elif defined(__NUTTX__)
-  int device_fd;
-#elif defined(__TIZENRT__)
-  iotbus_pwm_context_h ctx;
-#endif
   uint32_t pin;
   double duty_cycle;
   double period;
@@ -54,21 +56,11 @@ typedef struct {
 } IOTJS_VALIDATED_STRUCT(iotjs_pwm_t);
 
 
-typedef bool (*pwm_func_ptr)(iotjs_pwm_t*);
-
-
-typedef struct {
-  pwm_func_ptr caller;
-  bool result;
-  PwmOp op;
-} iotjs_pwm_reqdata_t;
-
-
 typedef struct {
   iotjs_reqwrap_t reqwrap;
   uv_work_t req;
   iotjs_pwm_reqdata_t req_data;
-  iotjs_pwm_t* pwm_instance;
+  iotjs_pwm_t* pwm_data;
 } IOTJS_VALIDATED_STRUCT(iotjs_pwm_reqwrap_t);
 
 
@@ -76,24 +68,21 @@ typedef struct {
 
 iotjs_pwm_reqwrap_t* iotjs_pwm_reqwrap_from_request(uv_work_t* req);
 iotjs_pwm_reqdata_t* iotjs_pwm_reqwrap_data(THIS);
-
 iotjs_pwm_t* iotjs_pwm_instance_from_reqwrap(THIS);
 
 #undef THIS
 
-
-#define PWM_WORKER_INIT                                                     \
-  iotjs_pwm_reqwrap_t* req_wrap = iotjs_pwm_reqwrap_from_request(work_req); \
-  iotjs_pwm_reqdata_t* req_data = iotjs_pwm_reqwrap_data(req_wrap);         \
-  iotjs_pwm_t* pwm = iotjs_pwm_instance_from_reqwrap(req_wrap);
-
-
-void iotjs_pwm_open_worker(uv_work_t* work_req);
-
+jerry_value_t iotjs_pwm_set_platform_config(iotjs_pwm_t* pwm,
+                                            const jerry_value_t jconfig);
+bool iotjs_pwm_open(iotjs_pwm_t* pwm);
 bool iotjs_pwm_set_period(iotjs_pwm_t* pwm);
 bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm);
 bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm);
 bool iotjs_pwm_close(iotjs_pwm_t* pwm);
 
+// Platform-related functions; they are implemented
+// by platform code (i.e.: linux, nuttx, tizen).
+void iotjs_pwm_create_platform_data(iotjs_pwm_t* pwm);
+void iotjs_pwm_destroy_platform_data(iotjs_pwm_platform_data_t* platform_data);
 
 #endif /* IOTJS_MODULE_PWM_H */
diff --git a/src/modules/linux/iotjs_module_pwm-linux.c b/src/modules/linux/iotjs_module_pwm-linux.c
index 1b1d8137d..49a7b5bf8 100644
--- a/src/modules/linux/iotjs_module_pwm-linux.c
+++ b/src/modules/linux/iotjs_module_pwm-linux.c
@@ -41,6 +41,43 @@
 #define PWM_PATH_BUFFER_SIZE 64
 #define PWM_VALUE_BUFFER_SIZE 32
 
+struct iotjs_pwm_platform_data_s {
+  int chip;
+  iotjs_string_t device;
+};
+
+void iotjs_pwm_create_platform_data(iotjs_pwm_t* pwm) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  _this->platform_data = IOTJS_ALLOC(iotjs_pwm_platform_data_t);
+  _this->platform_data->chip = 0;
+}
+
+void iotjs_pwm_destroy_platform_data(iotjs_pwm_platform_data_t* pdata) {
+  iotjs_string_destroy(&pdata->device);
+  IOTJS_RELEASE(pdata);
+}
+
+jerry_value_t iotjs_pwm_set_platform_config(iotjs_pwm_t* pwm,
+                                            const jerry_value_t jconfig) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
+  jerry_value_t jchip =
+      iotjs_jval_get_property(jconfig, IOTJS_MAGIC_STRING_CHIP);
+
+  if (jerry_value_has_error_flag(jchip)) {
+    return jchip;
+  }
+
+  if (jerry_value_is_number(jchip)) {
+    platform_data->chip = iotjs_jval_as_number(jchip);
+  } else {
+    platform_data->chip = 0;
+  }
+
+  jerry_release_value(jchip);
+
+  return jerry_create_undefined();
+}
 
 // Generate device path for specified PWM device.
 // The path may include node suffix if passed ('enable', 'period', 'duty_cycle')
@@ -77,61 +114,60 @@ static double adjust_period(double period) {
 }
 
 
-void iotjs_pwm_open_worker(uv_work_t* work_req) {
-  PWM_WORKER_INIT;
+bool iotjs_pwm_open(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
   char path[PWM_PATH_BUFFER_SIZE] = { 0 };
-  if (snprintf(path, PWM_PATH_BUFFER_SIZE, PWM_PIN_FORMAT, _this->chip,
+  if (snprintf(path, PWM_PATH_BUFFER_SIZE, PWM_PIN_FORMAT, platform_data->chip,
                _this->pin) < 0) {
-    req_data->result = false;
-    return;
+    return false;
   }
 
-  _this->device = iotjs_string_create_with_size(path, strlen(path));
+  platform_data->device = iotjs_string_create_with_size(path, strlen(path));
 
   // See if the PWM is already opened.
   if (!iotjs_systemio_check_path(path)) {
     // Write exporting PWM path
     char export_path[PWM_PATH_BUFFER_SIZE] = { 0 };
-    snprintf(export_path, PWM_PATH_BUFFER_SIZE, PWM_EXPORT, _this->chip);
+    snprintf(export_path, PWM_PATH_BUFFER_SIZE, PWM_EXPORT,
+             platform_data->chip);
 
     const char* created_files[] = { PWM_PIN_DUTYCYCLE, PWM_PIN_PERIOD,
                                     PWM_PIN_ENABlE };
     int created_files_length = sizeof(created_files) / sizeof(created_files[0]);
     if (!iotjs_systemio_device_open(export_path, _this->pin, path,
                                     created_files, created_files_length)) {
-      req_data->result = false;
-      return;
+      return false;
     }
   }
 
   // Set options.
   if (_this->period >= 0) {
     if (!iotjs_pwm_set_period(pwm)) {
-      req_data->result = false;
-      return;
+      return false;
     }
     if (_this->duty_cycle >= 0) {
       if (!iotjs_pwm_set_dutycycle(pwm)) {
-        req_data->result = false;
-        return;
+        return false;
       }
     }
   }
 
   DDDLOG("%s - path: %s", __func__, path);
 
-  req_data->result = true;
+  return true;
 }
 
 
 bool iotjs_pwm_set_period(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
   bool result = false;
   if (isfinite(_this->period) && _this->period >= 0.0) {
-    char* devicePath = generate_device_subpath(&_this->device, PWM_PIN_PERIOD);
+    char* devicePath =
+        generate_device_subpath(&platform_data->device, PWM_PIN_PERIOD);
     if (devicePath) {
       // Linux API uses nanoseconds, thus 1E9
       unsigned int value = (unsigned)(adjust_period(_this->period) * 1.E9);
@@ -149,13 +185,14 @@ bool iotjs_pwm_set_period(iotjs_pwm_t* pwm) {
 
 bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
   bool result = false;
   double dutyCycle = _this->duty_cycle;
   if (isfinite(_this->period) && _this->period >= 0.0 && isfinite(dutyCycle) &&
       0.0 <= dutyCycle && dutyCycle <= 1.0) {
     char* devicePath =
-        generate_device_subpath(&_this->device, PWM_PIN_DUTYCYCLE);
+        generate_device_subpath(&platform_data->device, PWM_PIN_DUTYCYCLE);
     if (devicePath) {
       double period = adjust_period(_this->period);
       // Linux API uses nanoseconds, thus 1E9
@@ -178,10 +215,11 @@ bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm) {
 
 bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
   bool result = false;
-
-  char* devicePath = generate_device_subpath(&_this->device, PWM_PIN_ENABlE);
+  char* devicePath =
+      generate_device_subpath(&platform_data->device, PWM_PIN_ENABlE);
   if (devicePath) {
     char value[4];
     if (snprintf(value, sizeof(value), "%d", _this->enable) < 0) {
@@ -203,9 +241,10 @@ bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
 
 bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
   char path[PWM_PATH_BUFFER_SIZE] = { 0 };
-  if (snprintf(path, PWM_PATH_BUFFER_SIZE, PWM_PIN_FORMAT, _this->chip,
+  if (snprintf(path, PWM_PATH_BUFFER_SIZE, PWM_PIN_FORMAT, platform_data->chip,
                _this->pin) < 0) {
     return false;
   }
@@ -214,7 +253,7 @@ bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
     // Write exporting pin path
     char unexport_path[PWM_PATH_BUFFER_SIZE] = { 0 };
     if (snprintf(unexport_path, PWM_PATH_BUFFER_SIZE, PWM_UNEXPORT,
-                 _this->chip) < 0) {
+                 platform_data->chip) < 0) {
       return false;
     }
 
diff --git a/src/modules/nuttx/iotjs_module_pwm-nuttx.c b/src/modules/nuttx/iotjs_module_pwm-nuttx.c
index f1b676cc8..c8c29bf54 100644
--- a/src/modules/nuttx/iotjs_module_pwm-nuttx.c
+++ b/src/modules/nuttx/iotjs_module_pwm-nuttx.c
@@ -28,11 +28,30 @@
 #define PWM_DEVICE_PATH_FORMAT "/dev/pwm%d"
 #define PWM_DEVICE_PATH_BUFFER_SIZE 12
 
+struct iotjs_pwm_platform_data_s {
+  int device_fd;
+};
 
-static bool iotjs_pwm_set_options(iotjs_pwm_t* pwm) {
+void iotjs_pwm_create_platform_data(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  _this->platform_data = IOTJS_ALLOC(iotjs_pwm_platform_data_t);
+  _this->platform_data->device_fd = -1;
+}
+
+void iotjs_pwm_destroy_platform_data(iotjs_pwm_platform_data_t* pdata) {
+  IOTJS_RELEASE(pdata);
+}
+
+jerry_value_t iotjs_pwm_set_platform_config(iotjs_pwm_t* pwm,
+                                            const jerry_value_t jconfig) {
+  return jerry_create_undefined();
+}
 
-  int fd = _this->device_fd;
+static bool pwm_set_options(iotjs_pwm_t* pwm) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
+
+  int fd = platform_data->device_fd;
   if (fd < 0) {
     DLOG("%s - file open failed", __func__);
     return false;
@@ -63,9 +82,7 @@ static bool iotjs_pwm_set_options(iotjs_pwm_t* pwm) {
   return true;
 }
 
-
-void iotjs_pwm_open_worker(uv_work_t* work_req) {
-  PWM_WORKER_INIT;
+bool iotjs_pwm_open(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
 
   int timer = SYSIO_GET_TIMER(_this->pin);
@@ -73,8 +90,7 @@ void iotjs_pwm_open_worker(uv_work_t* work_req) {
 
   if (snprintf(path, PWM_DEVICE_PATH_BUFFER_SIZE, PWM_DEVICE_PATH_FORMAT,
                timer) < 0) {
-    req_data->result = false;
-    return;
+    return false;
   }
 
   struct pwm_lowerhalf_s* pwm_lowerhalf =
@@ -83,41 +99,37 @@ void iotjs_pwm_open_worker(uv_work_t* work_req) {
   DDDLOG("%s - path: %s, timer: %d\n", __func__, path, timer);
 
   if (pwm_register(path, pwm_lowerhalf) != 0) {
-    req_data->result = false;
-    return;
+    return false;
   }
 
   // File open
-  _this->device_fd = open(path, O_RDONLY);
-  if (_this->device_fd < 0) {
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
+  platform_data->device_fd = open(path, O_RDONLY);
+  if (platform_data->device_fd < 0) {
     DLOG("%s - file open failed", __func__);
-    req_data->result = false;
-    return;
+    return false;
   }
 
-  if (!iotjs_pwm_set_options(pwm)) {
-    req_data->result = false;
-    return;
+  if (!pwm_set_options(pwm)) {
+    return false;
   }
 
-  req_data->result = true;
+  return true;
 }
 
-
 bool iotjs_pwm_set_period(iotjs_pwm_t* pwm) {
-  return iotjs_pwm_set_options(pwm);
+  return pwm_set_options(pwm);
 }
 
-
 bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm) {
-  return iotjs_pwm_set_options(pwm);
+  return pwm_set_options(pwm);
 }
 
-
 bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  int fd = _this->device_fd;
+  int fd = platform_data->device_fd;
   if (fd < 0) {
     DLOG("%s - file open failed", __func__);
     return false;
@@ -140,11 +152,11 @@ bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
   return true;
 }
 
-
 bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  int fd = _this->device_fd;
+  int fd = platform_data->device_fd;
   if (fd < 0) {
     DLOG("%s - file not opened", __func__);
     return false;
@@ -154,7 +166,7 @@ bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
 
   // Close file
   close(fd);
-  _this->device_fd = -1;
+  platform_data->device_fd = -1;
 
   uint32_t timer = SYSIO_GET_TIMER(_this->pin);
   char path[PWM_DEVICE_PATH_BUFFER_SIZE] = { 0 };
diff --git a/src/modules/tizenrt/iotjs_module_pwm-tizenrt.c b/src/modules/tizenrt/iotjs_module_pwm-tizenrt.c
index a61ffc823..5a8272dcf 100644
--- a/src/modules/tizenrt/iotjs_module_pwm-tizenrt.c
+++ b/src/modules/tizenrt/iotjs_module_pwm-tizenrt.c
@@ -23,11 +23,30 @@
 
 #include "modules/iotjs_module_pwm.h"
 
-static bool iotjs_pwm_set_options(iotjs_pwm_t* pwm) {
+struct iotjs_pwm_platform_data_s {
+  iotbus_pwm_context_h ctx;
+};
+
+void iotjs_pwm_create_platform_data(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  _this->platform_data = IOTJS_ALLOC(iotjs_pwm_platform_data_t);
+  _this->platform_data->device_fd = -1;
+}
 
-  iotbus_pwm_context_h ctx = _this->ctx;
-  if (ctx == NULL) {
+void iotjs_pwm_destroy_platform_data(iotjs_pwm_platform_data_t* pdata) {
+  IOTJS_RELEASE(pdata);
+}
+
+jerry_value_t iotjs_pwm_set_platform_config(iotjs_pwm_t* pwm,
+                                            const jerry_value_t jconfig) {
+  return jerry_create_undefined();
+}
+
+static bool pwm_set_options(iotjs_pwm_t* pwm) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
+
+  if (platform_data->ctx == NULL) {
     DLOG("%s - file open failed", __func__);
     return false;
   }
@@ -38,29 +57,28 @@ static bool iotjs_pwm_set_options(iotjs_pwm_t* pwm) {
   return iotjs_pwm_set_dutycycle(pwm) && iotjs_pwm_set_period(pwm);
 }
 
-void iotjs_pwm_open_worker(uv_work_t* work_req) {
-  PWM_WORKER_INIT;
+bool iotjs_pwm_open(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  _this->ctx = iotbus_pwm_open(0, (int)_this->pin);
-  if (_this->ctx == NULL) {
+  platform_data->ctx = iotbus_pwm_open(0, (int)_this->pin);
+  if (platform_data->ctx == NULL) {
     DLOG("%s - file open failed", __func__);
-    req_data->result = false;
-    return;
+    return false;
   }
 
-  if (!iotjs_pwm_set_options(pwm)) {
-    req_data->result = false;
-    return;
+  if (!pwm_set_options(pwm)) {
+    return false;
   }
 
-  req_data->result = true;
+  return true;
 }
 
 bool iotjs_pwm_set_period(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  iotbus_pwm_context_h ctx = _this->ctx;
+  iotbus_pwm_context_h ctx = platform_data->ctx;
   if (ctx == NULL) {
     DLOG("%s - file open failed", __func__);
     return false;
@@ -71,11 +89,11 @@ bool iotjs_pwm_set_period(iotjs_pwm_t* pwm) {
   return iotbus_pwm_set_period(ctx, period_us) == 0;
 }
 
-
 bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  iotbus_pwm_context_h ctx = _this->ctx;
+  iotbus_pwm_context_h ctx = platform_data->ctx;
   if (ctx == NULL) {
     DLOG("%s - file open failed", __func__);
     return false;
@@ -86,11 +104,11 @@ bool iotjs_pwm_set_dutycycle(iotjs_pwm_t* pwm) {
   return iotbus_pwm_set_duty_cycle(ctx, duty_cycle_per_cent) == 0;
 }
 
-
 bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  iotbus_pwm_context_h ctx = _this->ctx;
+  iotbus_pwm_context_h ctx = platform_data->ctx;
   if (ctx == NULL) {
     DLOG("%s - file open failed", __func__);
     return false;
@@ -115,8 +133,9 @@ bool iotjs_pwm_set_enable(iotjs_pwm_t* pwm) {
 
 bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_pwm_t, pwm);
+  iotjs_pwm_platform_data_t* platform_data = _this->platform_data;
 
-  iotbus_pwm_context_h ctx = _this->ctx;
+  iotbus_pwm_context_h ctx = platform_data->ctx;
   if (ctx == NULL) {
     DLOG("%s - file not opened", __func__);
     return false;
@@ -125,7 +144,7 @@ bool iotjs_pwm_close(iotjs_pwm_t* pwm) {
   DDDLOG("%s", __func__);
 
   iotbus_pwm_close(ctx);
-  _this->ctx = NULL;
+  platform_data->ctx = NULL;
 
   return true;
 }
diff --git a/test/run_pass/test_pwm_async.js b/test/run_pass/test_pwm_async.js
index 78f978128..44bbe7f12 100644
--- a/test/run_pass/test_pwm_async.js
+++ b/test/run_pass/test_pwm_async.js
@@ -14,12 +14,10 @@
  */
 
 var assert = require('assert');
-var Pwm = require('pwm');
+var pwm = require('pwm');
 var pin = require('tools/systemio_common').pin;
 var checkError = require('tools/systemio_common').checkError;
 
-var pwm = new Pwm();
-
 var dutyCycles = [0.25, 0.5, 0.75],
     frequencies = [1, 10, 30],
     periodInit = false,
@@ -47,7 +45,7 @@ pwm0 = pwm.open(configuration, function (err) {
   console.log('PWM initialized');
   checkError(err);
 
-  pwm0.setEnable(1, checkError);
+  pwm0.setEnable(true, checkError);
   dutyCycleTest();
 });
 
@@ -81,7 +79,7 @@ function frequencyTest() {
 
     if (loopCnt >= frequencies.length) {
       clearInterval(loop);
-      pwm0.setEnable(0, function(err) {
+      pwm0.setEnable(false, function(err) {
         checkError(err);
         pwm0.close(function(err) {
           checkError(err);
diff --git a/test/run_pass/test_pwm_sync.js b/test/run_pass/test_pwm_sync.js
index c01c85fac..f4b293aaf 100644
--- a/test/run_pass/test_pwm_sync.js
+++ b/test/run_pass/test_pwm_sync.js
@@ -14,12 +14,10 @@
  */
 
 var assert = require('assert');
-var Pwm = require('pwm');
+var pwm = require('pwm');
 var pin = require('tools/systemio_common').pin;
 var checkError = require('tools/systemio_common').checkError;
 
-var pwm = new Pwm();
-
 var dutyCycles = [0.25, 0.5, 0.75],
     frequencies = [1, 10, 30];
 
@@ -35,13 +33,11 @@ function initPwm(pwm) {
 }
 
 var pwm0 = null;
-pwm0 = pwm.open(configuration, function (err) {
-  console.log('PWM initialized');
-  checkError(err);
+pwm0 = pwm.openSync(configuration);
+console.log('PWM initialized');
 
-  pwm0.setEnableSync(1);
-  dutyCycleTest();
-});
+pwm0.setEnableSync(true);
+dutyCycleTest();
 
 function dutyCycleTest() {
   var loopCnt = 0;
@@ -69,7 +65,7 @@ function frequencyTest() {
   var loop = setInterval(function() {
     if (loopCnt >= frequencies.length) {
       clearInterval(loop);
-      pwm0.setEnableSync(0);
+      pwm0.setEnableSync(false);
       pwm0.closeSync();
       console.log('PWM frequency test complete');
       return;
